## pgtap 0.24

=== Makefile ===
--- 
+++ 
@@ -6,14 +6,13 @@
 REGRESS = $(patsubst sql/%.sql,%,$(TESTS))
 REGRESS_OPTS = --load-language=plpgsql
 
-# Figure out where pg_config is, and set other vars we'll need depending on
-# whether or not we're in the source tree.
-ifdef USE_PGXS
+ifdef NO_PGXS
+top_builddir = ../..
+PG_CONFIG := $(top_builddir)/src/bin/pg_config/pg_config
+else
+# Run pg_config to get the PGXS Makefiles
 PG_CONFIG = pg_config
 PGXS := $(shell $(PG_CONFIG) --pgxs)
-else
-top_builddir = ../..
-PG_CONFIG := $(top_builddir)/src/bin/pg_config/pg_config
 endif
 
 # We need to do various things with various versions of PostgreSQL.
@@ -21,28 +20,20 @@
 PGVER_MAJOR = $(shell echo $(VERSION) | awk -F. '{ print ($$1 + 0) }')
 PGVER_MINOR = $(shell echo $(VERSION) | awk -F. '{ print ($$2 + 0) }')
 PGVER_PATCH = $(shell echo $(VERSION) | awk -F. '{ print ($$3 + 0) }')
-PGTAP_VERSION = 0.23
+PGTAP_VERSION = 0.24
+
+# We support 8.0 and later.
+ifneq ($(PGVER_MAJOR), 8)
+ifneq ($(PGVER_MAJOR), 9)
+$(error pgTAP requires PostgreSQL 8.0 or later. This is $(VERSION))
+endif
+endif
 
 # Compile the C code only if we're on 8.3 or older.
-ifeq ($(PGVER_MINOR), 3)
+ifeq ($(PGVER_MAJOR), 8)
+ifneq ($(PGVER_MINOR), 4)
 MODULES = pgtap
 endif
-ifeq ($(PGVER_MINOR), 2)
-MODULES = pgtap
-endif
-ifeq ($(PGVER_MINOR), 1)
-MODULES = pgtap
-endif
-ifeq ($(PGVER_MINOR), 0)
-MODULES = pgtap
-endif
-
-# Load up the PostgreSQL makefiles.
-ifdef PGXS
-include $(PGXS)
-else
-include $(top_builddir)/src/Makefile.global
-include $(top_srcdir)/contrib/contrib-global.mk
 endif
 
 # We need Perl.
@@ -50,14 +41,17 @@
 PERL := $(shell which perl)
 endif
 
+# Load PGXS now that we've set all the variables it might need.
+ifdef NO_PGXS
+include $(top_builddir)/src/Makefile.global
+include $(top_srcdir)/contrib/contrib-global.mk
+else
+include $(PGXS)
+endif
+
 # Is TAP::Harness installed?
 ifdef PERL
 HAVE_HARNESS := $(shell $(PERL) -le 'eval { require TAP::Harness }; print 1 unless $$@' )
-endif
-
-# We support 8.0 and later.
-ifneq ($(PGVER_MAJOR), 8)
-$(error pgTAP requires PostgreSQL 8.0 or later. This is $(VERSION))
 endif
 
 # Set up extra substitutions based on version numbers.
@@ -73,8 +67,6 @@
 REGRESS := $(filter-out enumtap valueset,$(REGRESS))
 endif
 ifeq ($(PGVER_MINOR), 0)
-# Hack for E'' syntax (<= PG8.0)
-EXTRA_SUBS := -e "s/ E'/ '/g"
 # Throw, runtests, enums, and roles aren't supported in 8.0.
 TESTS := $(filter-out sql/throwtap.sql sql/runtests.sql sql/enumtap.sql sql/roletap.sql sql/valueset.sql,$(TESTS))
 REGRESS := $(filter-out throwtap runtests enumtap roletap valueset,$(REGRESS))
@@ -94,39 +86,36 @@
 endif
 
 pgtap.sql: pgtap.sql.in test_setup.sql
-ifdef TAPSCHEMA
-	sed -e 's,TAPSCHEMA,$(TAPSCHEMA),g' -e 's/^-- ## //g' -e 's,MODULE_PATHNAME,$$libdir/pgtap,g' -e 's,__OS__,$(OSNAME),g' -e 's,__VERSION__,$(PGTAP_VERSION),g' $(EXTRA_SUBS) pgtap.sql.in > pgtap.sql
-else
-	sed -e 's,MODULE_PATHNAME,$$libdir/pgtap,g' -e 's,__OS__,$(OSNAME),g' -e 's,__VERSION__,$(PGTAP_VERSION),g' $(EXTRA_SUBS) pgtap.sql.in > pgtap.sql
-endif
+	cp $< $@
 ifeq ($(PGVER_MAJOR), 8)
 ifneq ($(PGVER_MINOR), 5)
 ifneq ($(PGVER_MINOR), 4)
-ifneq ($(PGVER_MINOR), 0)
 	patch -p0 < compat/install-8.3.patch
-endif
 ifneq ($(PGVER_MINOR), 3)
-ifeq ($(PGVER_MINOR), 2)
 	patch -p0 < compat/install-8.2.patch
-else
-ifeq ($(PGVER_MINOR), 1)
-	patch -p0 < compat/install-8.2.patch
+ifneq ($(PGVER_MINOR), 2)
 	patch -p0 < compat/install-8.1.patch
-else
+ifneq ($(PGVER_MINOR), 1)
 	patch -p0 < compat/install-8.0.patch
+#	Hack for E'' syntax (<= PG8.0)
+	mv pgtap.sql pgtap.tmp
+	sed -e "s/ E'/ '/g" pgtap.tmp > pgtap.sql
+	rm pgtap.tmp
 endif
 endif
 endif
 endif
 endif
 endif
+ifdef TAPSCHEMA
+	sed -e 's,TAPSCHEMA,$(TAPSCHEMA),g' -e 's/^-- ## //g' -e 's,MODULE_PATHNAME,$$libdir/pgtap,g' -e 's,__OS__,$(OSNAME),g' -e 's,__VERSION__,$(PGTAP_VERSION),g' pgtap.sql > pgtap.tmp
+else
+	sed -e 's,MODULE_PATHNAME,$$libdir/pgtap,g' -e 's,__OS__,$(OSNAME),g' -e 's,__VERSION__,$(PGTAP_VERSION),g' pgtap.sql > pgtap.tmp
+endif
+	mv pgtap.tmp pgtap.sql
 
 uninstall_pgtap.sql: uninstall_pgtap.sql.in test_setup.sql
-ifdef TAPSCHEMA
-	sed -e 's,TAPSCHEMA,$(TAPSCHEMA),g' -e 's/^-- ## //g' uninstall_pgtap.sql.in > uninstall_pgtap.sql
-else
 	cp uninstall_pgtap.sql.in uninstall_pgtap.sql
-endif
 ifeq ($(PGVER_MAJOR), 8)
 ifneq ($(PGVER_MINOR), 5)
 ifneq ($(PGVER_MINOR), 4)
@@ -139,6 +128,10 @@
 endif
 endif
 endif
+endif
+ifdef TAPSCHEMA
+	sed -e 's,TAPSCHEMA,$(TAPSCHEMA),g' -e 's/^-- ## //g' uninstall_pgtap.sql > uninstall.tmp
+	mv uninstall.tmp uninstall_pgtap.sql
 endif
 
 # Build pg_prove and holler if there's no Perl or TAP::Harness.
@@ -183,5 +176,6 @@
 
 html:
 	markdown -F 0x1000 README.pgtap > readme.html
-	perl -ne 'BEGIN { $$prev = 0; $$lab = ""; print "<h1>Contents</h1>\n<ul>\n" } if (m{<h([123])\s+id="([^"]+)">((<code>[^(]+)?.+?)</h\1>}) { next if $$lab && $$lab eq $$4; $$lab = $$4; if ($$prev) { if ($$1 != $$prev) { print $$1 > $$prev ? $$1 - $$prev > 1 ? "<ul><li><ul>" : "<ul>\n" : $$prev - $$1 > 1 ? "</li></ul></li></ul></li>\n" : "</li></ul></li>\n"; $$prev = $$1; } else { print "</li>\n" } } else { $$prev = $$1; } print qq{<li><a href="#$$2">} . ($$4 ? "$$4()</code>" : $$3) . "</a>" } END { print "</li>\n</ul>\n" }' readme.html > toc.html
+	perl -ne 'BEGIN { $$prev = 0; $$lab = ""; print "<h1>Contents</h1>\n<ul>\n" } if (m{<h([123])\s+id="`([^(]+)(?:[^"]+)">((<code>[^(]+)?.+?)</h\1>}) { next if $$lab && $$lab eq $$4; $$lab = $$4; if ($$prev) { if ($$1 != $$prev) { print $$1 > $$prev ? $$1 - $$prev > 1 ? "<ul><li><ul>" : "<ul>\n" : $$prev - $$1 > 1 ? "</li></ul></li></ul></li>\n" : "</li></ul></li>\n"; $$prev = $$1; } else { print "</li>\n" } } else { $$prev = $$1; } print qq{<li><a href="#$$2">} . ($$4 ? "$$4()</code>" : $$3) . "</a>" } END { print "</li>\n</ul>\n" }' readme.html > toc.html
+	perl -pi -e 'BEGIN { my %seen }; s{(<h[123]\s+id=")`([^(]+)[^"]+}{"$$1$$2" . ($$seen{$$2}++ || "")}ge;' readme.html
 	PERL5LIB=/Users/david/dev/perl/Pod-Simple/lib perldoc -MPod::Simple::XHTML -d pg_prove.pod.html -w html_header_tags:'<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">' bin/pg_prove
