=== debian/changelog ===
pgtap (0.90.0-1) unstable; urgency=low

  * Imported Upstream version 0.90.0
  * Switch to dpkg-source 3.0 (quilt) format
  * Add Recommends on libtap-parser-sourcehandler-pgtap-perl (Closes: #642196)
  * Add Recommends on libtap-harness-archive-perl (Closes: #590801)
  * Fix path for documentation file.
  * Convert to DH version 8

 -- Pierre Chifflier <pollux@debian.org>  Mon, 05 Dec 2011 00:03:13 +0100

pgtap (0.25.0-2) unstable; urgency=low

  * Set build-dep to postgresql-server-dev-all
  * Backport upstream commit 461fa22: Removed use of `relistemp` column in an
    internal function, as it has been removed in PostgreSQL 9.1
    Thanks to David E. Wheeler for the patch (Closes: #640563, #640165)
  * Make package architecture independent, the C module is not required since
    PostgreSQL 8.4 (Closes: #590798)
  * Bump Standards Version to 3.9.2

 -- Pierre Chifflier <pollux@debian.org>  Mon, 12 Sep 2011 00:11:30 +0200

pgtap (0.25.0-1) unstable; urgency=low

  * Imported Upstream version 0.25.0
  * Update build-dep to postgresql-server-dev-9.0 (Closes: #618234)
  * Update homepage (Closes: #590802)
  * pg_prove has been removed from upstream package and is shipped in a
    separate package (TAP::Parser::SourceHandler::pgTAP)
    This is not yet packaged, but will be in a near future.
  * Bump Standards Version to 3.9.1 (no changes)

 -- Pierre Chifflier <pollux@debian.org>  Mon, 28 Mar 2011 14:12:04 +0200

pgtap (0.24-1) unstable; urgency=low

  * Imported Upstream version 0.24
  * Bump Standards version to 3.9.0

 -- Pierre Chifflier <pollux@debian.org>  Tue, 20 Jul 2010 14:38:51 +0200

pgtap (0.23-2) unstable; urgency=low

  * Move pg_prove to /usr/bin (Closes: #568106)
  * Bump standards version to 3.8.4

 -- Pierre Chifflier <pollux@debian.org>  Sun, 21 Feb 2010 20:07:36 +0100

pgtap (0.23-1) unstable; urgency=low

  * New upstream release

 -- Pierre Chifflier <pollux@debian.org>  Wed, 30 Dec 2009 11:08:22 +0100

pgtap (0.22-1) unstable; urgency=low

  * New Upstream Version
  * Bump standards version to 3.8.3 (no changes)

 -- Pierre Chifflier <pollux@debian.org>  Tue, 18 Aug 2009 15:03:50 +0200

pgtap (0.21-3) unstable; urgency=low

  * Update build-depend to postgresql-server-dev-8.4 (Closes: #536968)

 -- Pierre Chifflier <pollux@debian.org>  Thu, 16 Jul 2009 19:13:44 +0200

pgtap (0.21-2) unstable; urgency=low

  * Change section to database (Closes: #534154)
  * Bump standards version to 3.8.2 (no changes)

 -- Pierre Chifflier <pollux@debian.org>  Mon, 22 Jun 2009 21:34:22 +0200

pgtap (0.21-1) unstable; urgency=low

  * New Upstream Version
  * Add watch file

 -- Pierre Chifflier <pollux@debian.org>  Sun, 07 Jun 2009 21:48:14 +0200

pgtap (0.20-2) unstable; urgency=low

  * Add dependency on libtest-harness-perl (Closes: #530837)

 -- Pierre Chifflier <pollux@debian.org>  Thu, 28 May 2009 15:32:21 +0200

pgtap (0.20-1) unstable; urgency=low

  * New Upstream Version
  * Bump standards version to 3.8.1 (no changes)

 -- Pierre Chifflier <pollux@debian.org>  Mon, 30 Mar 2009 18:07:52 +0200

pgtap (0.19-1) unstable; urgency=low

  * New Upstream Version

 -- Pierre Chifflier <pollux@debian.org>  Tue, 10 Mar 2009 09:50:40 +0100

pgtap (0.16-1) unstable; urgency=low

  * New Upstream Version

 -- Pierre Chifflier <pollux@debian.org>  Wed, 04 Feb 2009 11:00:50 +0100

pgtap (0.14-1) unstable; urgency=low

  * New upstream release

 -- Pierre Chifflier <pollux@debian.org>  Tue, 28 Oct 2008 09:18:55 +0100

pgtap (0.12-2) unstable; urgency=low

  * Add missing build-dep on postgresql-server-dev-8.3 (fix FTBFS)

 -- Pierre Chifflier <pollux@debian.org>  Mon, 27 Oct 2008 09:19:26 +0100

pgtap (0.12-1) unstable; urgency=low

  * Initial release (Closes: #500671)

 -- Pierre Chifflier <pollux@debian.org>  Mon, 13 Oct 2008 09:51:43 +0200
