=== debian/control ===
Source: pgtap
Priority: extra
Maintainer: Pierre Chifflier <pollux@debian.org>
Build-Depends: debhelper (>= 8),
    libpq-dev (>= 8.0),
    postgresql-server-dev-all (>= 116)
Standards-Version: 3.9.2
Section: database
Homepage: http://pgtap.org/

Package: pgtap
Section: database
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends},
    ${perl:Depends},
    libtest-harness-perl,
    libpq5 (>= 8.0)
Recommends: libtap-parser-sourcehandler-pgtap-perl,
    libtap-harness-archive-perl
Description: Unit testing framework for PostgreSQL
 pgTAP is a suite of database functions that make it easy to write
 TAP-emitting unit tests in psql scripts suitable for harvesting,
 analysis, and reporting by a TAP harness, such as those used in Perl
 and PHP applications.
 TAP is the Test Anything Protocol (http://testanything.org/).
