=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Written by Pierre Chifflier <pollux@debian.org>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


%:
	dh $@
