=== debian/watch ===
# watch control file for uscan
# run the "uscan" command to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

http://pgfoundry.org/frs/?group_id=1000389 /frs/download.php/.*/pgtap-(.*)\.tar\.gz
